package alx.data;

import alx.model.Employee;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;
import java.util.Optional;

@Controller
@RequestMapping("/emps9")
public class Controller9 {
    @Autowired
    private Repository9 repo;

    @GetMapping
    public String readAll(Model model) {
        List<Employee> employees = repo.findAll();
        model.addAttribute("emps", employees);
        return "employees.html";
    }

    @GetMapping("/{id}")
    public String readOne(@PathVariable("id") Integer employeeId, Model model) {
        Optional<Employee> employees = repo.findById(employeeId);
        if(employees.isPresent()) {
            model.addAttribute("emps", List.of(employees.get()));
        }
        return "employees.html";
    }

    @GetMapping("/by_name")
    public String showByName(Model model,
                             @RequestParam("name") String name) {
        List<Employee> emps = repo.findByLastName(name);
        model.addAttribute("emps", emps);
        return "employees.html";
    }
}
