package alx.rest;

import alx.data.LocationRespository;
import alx.model.Location;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.server.ResponseStatusException;

import java.util.List;

@RestController
@RequestMapping("/locations")
public class LocationsJson {
    @Autowired
    private LocationRespository repo;

    @GetMapping
    public List<Location> readAll() {
        return repo.findAll();
    }

    @GetMapping("/{id}")
    public Location readOne(@PathVariable Integer id) {
        return repo.findById(id).orElseThrow(() -> new ResponseStatusException(
                HttpStatus.NOT_FOUND, "Location Not Found"));
    }

}
